/* LED(port_d[5,4,3] control*/

#include <usb.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#define VENDOR_ID   0x1384		 /*VID must be changed. */
#define PRODUCT_ID  0x8888		 /*PID must be changed. */
#define interval    1		 /* every interval time temperature measured */

static int usbOpenDevice(usb_dev_handle **device, int idvendor, int idproduct)
{
	struct usb_bus *bus;
	struct usb_device *dev;
	usb_dev_handle *udh=NULL;
	int ret,retp, retm,errors;
	char string[256];

	usb_init();
	ret=usb_find_busses(); 
	retp=usb_find_devices(); if(ret!=retp){return errors=1;} 
	for (bus = usb_busses; bus; bus = bus->next)
	{
		for (dev = bus->devices; dev; dev = dev->next)
		{
			udh=usb_open(dev);
			retp = usb_get_string_simple(udh, dev->descriptor.iProduct, string, sizeof(string));
			retm = usb_get_string_simple(udh, dev->descriptor.iManufacturer, string, sizeof(string));
			if (retp > 0 && retm > 0)
				if (idvendor==dev->descriptor.idVendor && idproduct==dev->descriptor.idProduct){ *device=udh;return errors=0;}
		}
	}
	usb_close(udh);return errors=1;
}


int main(int argc, char **argv)
{
	usb_dev_handle *d=NULL;
	unsigned char buffer[7];
	int port_d;
	int mode;
	int ret;

//input
	if(argc<2){printf("you need LED data\n");return 0;}
	port_d=((atoi(argv[1]) << 3) & 0x00ff);

//check
	ret=usbOpenDevice(&d,VENDOR_ID,PRODUCT_ID);
	if(ret!=0){ printf("Plugin your USB device%d \n",ret); return 0;}

//write
	mode=1;	//write
	ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN, mode, port_d, 0, (char *)buffer, sizeof(buffer), 5000);

//read
	mode=0;	//read
	ret=usb_control_msg(d, USB_TYPE_VENDOR | USB_RECIP_DEVICE | USB_ENDPOINT_IN, mode, 0, 0, (char *)buffer, sizeof(buffer), 5000);
	printf("LED  d %2x\n",( buffer[0] & 0x38) >> 3);
	printf("PUSH d %2x\n",(~buffer[0] & 0x40) >> 6);
	printf("JUMP b %2x\n", ~buffer[1] & 0x0f      );

	return 0;
}
