/*date:May 9, 2007 by takefuji
analog tiny2313 via usb for tragi
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "usbdrv.h"

void delay(unsigned int p)
{
    unsigned char i;  
    unsigned char j;	 //one loop is 3.8us with 12MHz
    for(i=0;i<p;i++)
        for(j=0;j<10;j++);
}

uchar usbFunctionSetup(uchar data[8])
{
    static uchar replybuf[8];						
    usbMsgPtr = replybuf;

//Read port_b/d 
    if(data[1] == 0){		
        replybuf[0] = PIND & 0x78;
        replybuf[1] = PINB & 0x0f;
        return 1;
    }
//Write port_d
    else if(data[1]==1){
        PORTD = 0x40 + (data[2] & 0x38);	
        return 2;
    }
    return -1;
}


int main(void)
{
    PORTD = 0x40;
    PORTB = 0x0F;		/* no pullups on USB and ISP pins */
    DDRD  = 0xBA;		/* all outputs except PD2 = INT0 and PD0*/
    DDRB  = 0xF0;      	/* all output except PB1*/
  
    usbInit();
    sei();
    for(;;){	        /* main event loop */
        usbPoll();
    }
    return 0;
}
